#ifndef DUCK_H_
#define DUCK_H_

#include "QuackBehavior.h"
#include "FlyBehavior.h"

class Duck
{
public:
    virtual ~Duck() {}

    void perform_quack() { quack_behavior->quack(); }
    void perform_fly()   { fly_behavior->fly(); }

    virtual void identify() = 0;

protected:
    QuackBehavior *quack_behavior;
    FlyBehavior   *fly_behavior;
};

#endif /* DUCK_H_ */
