#ifndef DUCKTYPES_H_
#define DUCKTYPES_H_

#include <iostream>
#include "Duck.h"
#include "Quack.h"
#include "Fly.h"

using namespace std;

class MallardDuck : public Duck
{
public:
    MallardDuck()
    {
        quack_behavior = new Quack();
        fly_behavior   = new Fly();
    }

    void identify() { cout << "Mallard duck" << endl; }
};

class RubberDuck : public Duck
{
public:
    RubberDuck()
    {
        quack_behavior = new Squeak();
        fly_behavior   = new NoFly();
    }

    void identify() { cout << "Rubber duck" << endl; }
};

#endif /* DUCKTYPES_H_ */
