#ifndef QUACK_H_
#define QUACK_H_

#include <iostream>
#include "QuackBehavior.h"

using namespace std;

class Quack : public QuackBehavior
{
public:
    void quack() { cout << "  Quack!" << endl; }
};

class Squeak : public QuackBehavior
{
public:
    void quack() { cout << "  Squeak!" << endl; }
};

class Mute : public QuackBehavior
{
public:
    void quack() { /* silent */ }
};

#endif /* QUACK_H_ */
